/***********************************************************************
 *
 * TITLE:
 *	shellmgmt.h
 *
 * AUTHOR:
 *	Kevin J. Miller
 *
 * DESCRIPTION:
 *	Sets correct response for modal Window Manager shells Close
 *	button.  Each time you create an Application Shell or a
 *	Modal Dialog, you should call ShellAddClose() to set the
 *	MWM Close behavior correctly.  When the Dialog is managed,
 *	use ShellModalManage() instead of XtManageChild(), and
 *	before unmanaging call ShellValidateClose() to see if
 *	the MWM Close button was legally selected, and finally
 *	unmanage with ShellModalUnmanage().
 *
 *				CHANGE HISTORY
 *
 * $Log: shellmgmt.h,v $
 * Revision 1.2  1994/11/22  00:36:30  kevin
 * added support for iconified main window
 *
 * Revision 1.1  1994/01/17  23:02:20  clm
 * Initial revision
 *
 ***********************************************************************
 *
 * WARNINGS:
 *
 * EXTERNAL CALLABLE COMPONENTS (PUBLIC):
 *
 * GLOBALS:
 *
 * WAIVERS:
 *
 * NOTES:
 *
 * MANPAGE:
 *
 ***********************************************************************/

#ifndef shellmgmt_h
#define shellmgmt_h

#ifndef lint
static char rcsid_shellmgmt[] = 
    "$Id: shellmgmt.h,v 1.2 1994/11/22 00:36:30 kevin OEL $";
#endif

/*
 * global function defintions
 */
extern void ShellAddClose(Widget, XtCallbackProc, XtPointer);
extern void ShellModalManage(Widget);
extern int ShellValidateClose(Widget);
extern void ShellModalUnmanage(Widget);
extern int ShellIsIconified(void);

#endif
