.TH XOPPS 1 "1 February 1995" "MGDS V20.1 / OEL 1.8" "MCA Subsystem"
.SH NAME
xopps - represents an application-specific editor with its commands and functions tailored to scheduling activities on a timeline display.
.SH SYNOPSIS
.B xopps
.LP
.SH DESCRIPTION
.B xopps
is an interactive window-based editing tool for planning and
scheduling project tasks.  It represents an application-specific
editor with its commands and functions tailored to scheduling
activities on a timeline display.  The editor also provides the user
with the ability to obtain a laser printout of the schedule.
.LP
.B xopps
is an X windows application that runs under the Motif Window Manager.
Once invoked, it is menu/mouse driven.  To bring up the file menu,
press and hold down the
.B left
mouse button while positioning the cursor over the word
.B File
on the menu bar.  Then move the mouse to position the cursor over the desired
action and release the mouse button.
.LP
The file menu options are:
.TP 1.1i
.B New
Clear the drawing area and create a new file.
.TP 1.1i
.B Open...
Load a file into the editor.
.TP 1.1i
.B Save
Save under the current file name.
.TP 1.1i
.B Save As...
Save the file with a new name.
.TP 1.1i
.B Print...
Output the schedule to the laser printer or to a PostScript file.
.TP 1.1i
.B Export Graphics...
Save the schedule as a Macintosh PICT and/or Windows META file.
.TP 1.1i
.B Exit
Exit the application.
.LP
The Options menu controls how the daily schedule is viewed.  To bring up the 
Options menu, press and hold down the
.B left
mouse button over the word
.B Options
on the menu bar.  Then move the cursor over the desired action and release 
the button.
.LP
The Options menu offers these choices:
.TP 1.1i
.BR "Set Dates"
Displays a popup that enables you to change the layout of the chart
start, end, and status dates.
.TP 1.1i
.BR "Renumber"
Toggles whether to automatically renumber the horizontal lines when changes
are made to the lines.  The toggle value will change when the mouse is
released over this option.
.TP 1.1i
.BR "Plot Setup"
Displays a popup that permits you to change the layout of the chart.
You can change the number of lines per page, the number of pages in the 
schedule, and the type of lines.
.TP 1.1i
.BR "Snap Events"
Toggles whether to allow event objects to move only on the y axis.
.TP 1.1i
.BR "Snap Text"
Toggles whether to allow text objects to move only on the y axis.
.TP 1.1i
.BR "Display DOY"
If this toggle is on, the UTC day of year will appear along the bottom of the
chart.
.TP 1.1i
.BR "Display ID"
If this toggle is on, the ID texts will be displayed with the objects.
.TP 1.1i
.BR "Page Forward"
Moves the chart one page forward in the schedule, if the page exists.
.TP 1.1i
.BR "Page Backward"
Moves the chart one page backward in the schedule, if the page exists.
.LP
Menu options also exist for editing the XOPPS file.  This second menu
is a popup menu and is located in the drawing area.  To bring up the
drawing area menu, position the cursor inside the drawing area and
hold down the
.B right
mouse button.  Move the cursor over the desired action and release the button.
.LP
The drawing area popup menu options offers these options:
.TP 1.1i
.B Copy
Copies the current object.
.TP 1.1i
.B Event to Slip
Copies all of the attributes of the event object into a slip object's
attributes.  Used to convert an event object to a slip object.
.TP 1.1i
.B Edit
Edit the current object.
.TP 1.1i
.B Delete
Delete the current object.
.TP 1.1i
.B Delete Pline
Delete the current precedence line.
.TP 1.1i
.B Add...
When the cursor is placed over the Add button, a submenu will appear
that contains the objects that may be added.  Note that some objects
cannot be added to every region of the drawing area.
.TP 1.5i
.I "	Activity"
.TP 2.0i
.I "            Simple"
Adds an object that represents an activity with no baseline object or ramps.
.TP 2.0i
.I "            Complex"
Adds an object that represents an activity associated with a start and end
time.  The activity might also have a percent complete date as well as a
baseline object and ramp up and down dates.
.TP 1.5i
.I "	Chart Date"
Adds an object that represents the start and end dates of the chart.
.TP 1.5i
.I "	Event"
Adds an object that represents an event associated with one time.
.TP 1.5i
.I " 	Image"
Adds an object that displays a bitmap image.
.TP 1.5i
.I "	Level"
Adds an object that represents the level the objects are on.
.TP 1.5i
.I "	Page"
Adds an object that represents the current page value.
.TP 1.5i
.I "	Sequence"
Adds an object that represents a sequence in the schedule.
.TP 1.5i
.I "	Slip"
Adds an object that represents a slip in the schedule.
.TP 1.5i
.I "	Status"
Adds an object that represents the status date of the file.
.TP 1.5i
.I "	Symbol"
Adds an object that represents a symbolic marker.
.TP 1.5i
.I "	Text"
Adds an object that displays text.
.LP
The drawing area also contains a pulldown menu for the horizontal
lines.  This menu is located in the left-hand region, before the chart
items begin.  To bring up the horizontal line menu, position the
cursor inside this region and hold down the
.B right
mouse button.  Move the cursor over the desired action and release the button.
.LP
The horizontal line menu offers these options:
.TP 1.1i
.B "Edit Hline"
Edits the horizontal line object.
.TP 1.1i
.B "Delete Hline"
Deletes the horizontal line object.
.TP 1.1i
.B "Insert New Line"
Inserts a new horizontal line above the current horizontal line object.
.TP 1.1i
.B "Line Display"
Toggles the line display.  If the toggle is on, the horizontal line is
displayed on the chart.
.TP 1.1i
.B "Number Display"
Toggles the number display.  If the toggle is on, the horizontal line number is
displayed on the chart.
.LP
The horizontal line area also contains an edit popup for adding or
editing the text of a horizontal line.  This text widget pops up by
positioning the cursor in the left-hand region of the chart and
holding down the
.B left
mouse button.  After editing your text, press the right mouse button
or the return key to unmanage the text widget and enter the text
into the horizontal line.  Pressing the left mouse button will
unmanage the text widget and cancel the edited text.
.LP
In the drawing area, precedence lines can also be drawn between
objects.  A precedence line can be drawn between any dated object --
i.e., activities, events, sequences, and slips -- to show any kind of
dependency.  To add a precedence line, position the cursor over one of
the objects and press the left button.  While holding down the left
mouse button, drag the cursor to the second object and release the
mouse button.  You will see a jogged line being drawn between the
first object and the cursor location as the mouse is dragged.  When
the button is released over the second object, a dotted precedence
line will be drawn between the two objects, with a jog at the center.
If either of the two objects is moved, the precedence line will move
with it.  If either of the two objects is deleted, the precedence line
will also be deleted.  To delete a precedence line, position the
cursor over the precedence line and press the right mouse button.  The
.B Delete Pline
option should appear on the operations menu.
.LP
.SH FILES
.TP 2.0i
.B *.xopps
A data file that defines an XOPPS file.
.TP 2.0i
.B /usr/lib/X11/app-defaults/XOpps
The resource file required for this application to function properly.
.SH RESOURCES
The name of the application is
.BR xopps
and its class is 
.BR XOpps .
Some of the resources that you may wish to customize in your
.B .Xdefaults
file are shown below.  These should generally be preceded by the application
name (e.g., "\fBxopps*maxWidth\fP").
.TP 2.0i
.B *drawingArea.background
The background color of the XOpps image.
.TP 2.0i
.B *drawingArea.foreground
The foreground color of the XOpps image.
.TP 2.0i
.B *swindow.width
A good way to set the startup width of the tool.
.TP 2.0i
.B *swindow.height
A good way to set the startup height of the tool.
.TP 2.0i
.B .maxWidth
Should be set so that you can't resize the tool beyond useful size.
.TP 2.0i
.B .maxHeight
Should be set so that you can't resize the tool beyond useful size.
.TP 2.0i
.B .res_font
Should be set to the desired default font, e.g., Courier.
.TP 2.0i
.B .res_point
Should be set to the desired default point size, e.g., 10.
.TP 2.0i
.B .week_monday
Should be set to TRUE to display weeks by Mondays, or FALSE to display
weeks by the 1st of the month.
.LP
.SH ENVIRONMENT
.TP 1.6i
.B LASERPRINTER
This is the name of the default PostScript printer.
.TP 1.6i
.B IMAGE_DIRECTORY
The \fBxopps\fP editor permits the user to place bitmap images on the
display.  After first checking the default directory, this directory
is checked for bitmap files.
.TP 1.6i
.B HELPPATH
The \fBxopps\fP editor contains on-line help.  This environment
variable should be set to the directory containing the
\fBxopps.info\fP file to read the help.
.TP 1.6i
.B PATH
This is the standard environment variable used to tell the program
where to look for executables.  The directory containing the
\fBxopps\fP editor must be appended to the path.
.LP
.SH BUGS
No known bugs.
